package com.bocloud.ams.booter.controller.collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.bocloud.ams.entity.collection.CollectionHistoryItem;
import com.bocloud.ams.service.collection.CollectionHistoryItemService;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;

@RestController
@RequestMapping("/v1/collection/history/item")
@Tag(name = "采集历史条目管理")
public class CollectionHistoryItemController {

    @Autowired
    private CollectionHistoryItemService collectionHistoryItemService;

    @Operation(tags = {"CMC"}, summary = "采集历史条目列表")
    @GetMapping
    public GeneralResult<GridBean<CollectionHistoryItem>> historyItems(Pager pager) {
        return collectionHistoryItemService.list(pager);
    }

    @Operation(tags = {"CMC"}, summary = "实例采集历史条目备份列表")
    @GetMapping("/backup")
    public GeneralResult<GridBean<CollectionHistoryItem>> backupHistoryItems(Pager pager) {
        return collectionHistoryItemService.backupHistoryItems(pager);
    }

}
