package com.bocloud.ams.booter.controller.instance;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.bocloud.ams.entity.instance.InstanceHistory;
import com.bocloud.ams.service.instance.InstanceHistoryService;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;

@RestController
@RequestMapping("/v1/instances/history")
@Tag(name = "实例变更记录管理")
public class InstanceHistoryController {

    @Autowired
    private InstanceHistoryService instanceHistoryService;

    /**
     * 模型实例变更记录
     *
     * @return
     */
    @Operation(tags = {"CMC"}, summary = "实例变更记录列表")
    @GetMapping
    public GeneralResult<GridBean<InstanceHistory>> history(Pager pager) {
        return instanceHistoryService.list(pager);
    }

}
