package com.bocloud.ams.booter.controller.module;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.bocloud.ams.entity.module.RegularExpression;
import com.bocloud.ams.service.module.RegularExpressionService;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.utils.Common;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;

@Tag(name =  "正则表达式管理")
@RestController
@RequestMapping("/v1/regexps")
public class RegularExpressionController {
    
    @Autowired
    private RegularExpressionService regularExpressionService;

    /**
     * 查询所有的正则表达式
     *
     * @return
     */
    @GetMapping
    @Operation(tags = {"CMC"}, summary ="正则表达式列表")
    public GeneralResult<List<RegularExpression>> list(@RequestParam(value = Common.TYPE) String type) {
        return regularExpressionService.list(type);
    }
}
