package com.bocloud.ams.entity.association;


import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * @Author liuyuanyuan
 * @Date 2022/5/9 0009 16:27
 * @Description:
 */
@Data
@Table("ci_auto_relation_rule")
@EqualsAndHashCode(callSuper = true)
public class AutoRelationRule extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column(value = "module_relation_id")
    private Long moduleRelationId;
    @Column(value = "relation_category_id")
    private Long relationCategoryId;
    @Column(value = "source_module_id")
    private Long sourceModuleId;
    @Column(value = "target_module_id")
    private Long targetModuleId;
    @IgnoreAll
    private List<AutoRelationRuleItem> items;
    @IgnoreAll
    private String sourceModuleName;
    @IgnoreAll
    private String targetModuleName;
    @IgnoreAll
    private String cmdbRelationCategoryName;
    @IgnoreAll
    private String cmdbRelationName;
    @IgnoreAll
    private String creator;
}
