package com.bocloud.ams.entity.collection;


import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @Author liuyuanyuan
 * @Date 2022/6/7 0007 13:39
 * @Description:
 */
@Data
@Table("ci_collection_component")
@EqualsAndHashCode(callSuper = true)
public class CollectionComponent extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("template_id")
    private Long templateId;
    @Column("type")
    private String type;
    @Column("title")
    private String title;
    @Column("input_form")
    private String inputForm;
    @Column("parameter_type")
    private String parameterType;
    @Column("module_id")
    private Long moduleId;
    @Column("module_code")
    private String moduleCode;
    @Column("property_id")
    private Long propertyId;
    @Column("property_code")
    private String propertyCode;
    @IgnoreAll
    private String creator;
    @IgnoreAll
    private String moduleName;
    @IgnoreAll
    private String propertyName;
}
