package com.bocloud.ams.entity.collection;


import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.entity.bean.Generic;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * @ClassName: CollectionHistory
 * @Description 采集记录
 * @Author yangzhenrong
 * @Date 2022/6/15 19:57
 * @Version 1.0
 **/
@Data
@Table("ci_collection_history")
@EqualsAndHashCode(callSuper = true)
public class CollectionHistory extends Generic {
    @PK
    private Long id;
    @Column(value = "module_id")
    private Long moduleId;
    @Column(value = "instance_id")
    private Long instanceId;
    @Column(value = "instance_uuid")
    private String instanceUuid;
    @Column(value = "task_instance_id", nullable = false)
    private Long taskInstanceId;
    @Column(value = "type", length = 64, nullable = false)
    private String type;//取值范围:ADD、EDIT
    @Column(value = "status", length = 64, nullable = false)
    private String status;//取值范围：SUCCESS、FAILED、RECONCILED未调和
    @Column(value = "output")
    private String output;//原始输出
    @Column(value = "operator", length = 128, nullable = false)
    private String operator;
    @Column(value = "gmt_create", length = 64, nullable = false)
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    @Column(value = "reason")
    private String reason;//原因
    @IgnoreAll
    private List<CollectionHistoryItem> historyItems;
    @IgnoreAll
    private String tableName;
}
