package com.bocloud.ams.entity.enums;


import com.megatron.common.model.GeneralResult;
import org.apache.commons.lang3.StringUtils;

/**
 * @Author liuyuanyuan
 * @Date 2022/6/7 0007 13:42
 * @Description:
 */
public class CollectionEnum {

    public enum Task {
        /**
         * 定时任务
         */
        SCHEDULED("scheduled"),
        /**
         * 标准任务
         */
        STANDARD("standard"),
        /**
         * 临时任务
         */
        TEMPORARY("temporary"),
        /**
         * 任务模板
         */
        TEMPLATE("template");

        public static GeneralResult<Task> hasValue(String value) {
            if (StringUtils.isEmpty(value)) {
                return new GeneralResult<>(false, "参数为空！");
            }
            Task[] tasks = Task.values();
            for (Task task : tasks) {
                if (task.name().equalsIgnoreCase(value)) {
                    return new GeneralResult<Task>(true, task, "success");
                }
            }
            return new GeneralResult<>(false, "数值不存在！");
        }

        private String value;

        Task(String value) {
            this.value = value;
        }

        public String getValue() {
            return this.value;
        }
    }

    /**
     * 任务执行状态
     */
    public enum Status {
        /**
         * 创建
         */
        CREATED,
        /**
         * 运行中
         */
        RUNNING,
        /**
         * 已暂停
         */
        SUSPENDED,
        /**
         * 成功
         */
        SUCCESS,
        /**
         * 失败
         */
        ERROR
    }

    public enum workerCode {
        //脚本
        SCRIPT("task.maintain.script"),
        //数据库
        DATABASE("task.maintain.database"),
        //接口
        METHOD("task.maintain.method");

        private final String value;

        workerCode(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    public enum collectionType {
        //脚本
        SCRIPT("script"),
        //数据库
        DATABASE("database"),
        //接口
        METHOD("method");

        private final String value;

        collectionType(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    public enum parameter {
        //输入参数
        INPUT("input"),
        //目标输入参数
        INPUT_TARGET("input_target"),
        //输出参数
        OUTPUT("output"),
        //对照参数
        CONTRAST("contrast");

        private final String value;

        parameter(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    public enum inputForm {
        //输入形式
        MANUAL("manual");
        private final String value;

        inputForm(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    public enum parameterType {
        //cmdb实例
        CMDB_INSTANCE("cmdb_instance"),
        //单行文本
        TEXT("text"),
        //加密数据
        ENCRYPT_DATA("encrypt_data"),
        //整数
        INTEGER("integer");

        private final String value;

        parameterType(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    public enum historyType {
        ADD("实例新增"),
        EDIT("实例变更"),
        NOUPDATE("无需更新"),
        NOTCOLLECTED("未采集");
        private final String value;

        historyType(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    public enum historyStatus {
        SUCCESS("执行成功"),
        FAILED("执行失败"),
        RECONCILED("未调和");
        private final String value;

        historyStatus(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    public enum historyOperate {
        CANCEL("取消"),
        UPDATE("更新");
        private final String value;

        historyOperate(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }
}
