package com.bocloud.ams.entity.instance;


import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.entity.bean.Generic;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @ClassName: CmdbInstanceHistory
 * @Description 实例操作记录
 * @Author yangzhenrong
 * @Date 2022/5/16 15:49
 * @Version 1.0
 **/
@Data
@Table("ci_instance_history")
@EqualsAndHashCode(callSuper = true)
public class InstanceHistory extends Generic {
    @PK
    private Long id;
    @Column(value = "module_id", nullable = false)
    private Long moduleId;
    @Column(value = "instance_id", nullable = false)
    private Long instanceId;
    @Column(value = "catalog", length = 64, nullable = false)
    private String catalog;//取值范围:INSTANCE、RELATION
    @Column(value = "category", length = 64, nullable = false)
    private String category;//取值范围：CREATE、MODIFY、REMOVE
    @Column(value = "content", length = 1024, nullable = false)
    private String content;
    @Column(value = "operator", length = 128, nullable = false)
    private String operator;
    @Column(value = "gmt_create", length = 64, nullable = false)
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;

    public InstanceHistory() {

    }

    public InstanceHistory(Long moduleId, Long instanceId, String catalog, String category, String content, String operator, Date gmtCreate) {
        this.moduleId = moduleId;
        this.instanceId = instanceId;
        this.catalog = catalog;
        this.category = category;
        this.content = content;
        this.operator = operator;
        this.gmtCreate = gmtCreate;
    }


}
