package com.bocloud.ams.entity.instance;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * @Author liuyuanyuan
 * @Date 2022/5/16 0016 14:09
 * @Description:
 */
@Data
@Table("ci_instance_relation")
@EqualsAndHashCode(callSuper = true)
public class InstanceRelation extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column(value = "relation_category_id", nullable = false)
    private Long relationCategoryId;
    @Column(value = "relation_category_code", nullable = false, length = 256)
    private String relationCategoryCode;
    @Column(value = "module_relation_id", nullable = false)
    private Long moduleRelationId;
    @Column(value = "module_relation_name", length = 256)
    private String moduleRelationName;
    @Column(value = "source_module_id", nullable = false)
    private Long sourceModuleId;
    @Column(value = "source_module_code", nullable = false, length = 256)
    private String sourceModuleCode;
    @Column(value = "source_instance_id", nullable = false)
    private Long sourceInstanceId;
    @Column(value = "source_instance_name", length = 256)
    private String sourceInstanceName;
    @Column(value = "target_module_id", nullable = false)
    private Long targetModuleId;
    @Column(value = "target_module_code", nullable = false, length = 256)
    private String targetModuleCode;
    @Column(value = "target_instance_id", nullable = false)
    private Long targetInstanceId;
    @Column(value = "target_instance_name", length = 256)
    private String targetInstanceName;
    /**
     * 关联方式： 手动-MANUAL  自动-AUTO
     */
    @Column(value = "way", length = 32)
    private String way;
    @IgnoreAll
    private String sourceType;
    @IgnoreAll
    private String targetType;
    @IgnoreAll
    private Long relationId;
    @IgnoreAll
    private String relationName;
    @IgnoreAll
    private List<InstanceRelation> cmdbInstanceRelations;

    /**
     * 实例之间的关系 与 模型定义之间的关系 是否一致
     * false 是一致 ； true 是相反
     */
    @IgnoreAll
    private Boolean isReversed = false;
    @IgnoreAll
    private String type;
    @IgnoreAll
    private Long currentModuleId;
    /**
     * 手动关系，标记当前操作的实例
     */
    @IgnoreAll
    private Long currentInstanceId;
}
