package com.bocloud.ams.entity.module;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * @Author liuyuanyuan
 * @Date 2022/4/29 0029 14:57
 * @Description:
 */
@Data
@Table("ci_module_group")
@EqualsAndHashCode(callSuper = true)
public class ModuleGroup extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("parent_id")
    private Long parentId;
    @Column("code")
    private String code;
    @Column("name_space")
    private String nameSpace;
    @IgnoreAll
    private List<CiModule> modules;
    @IgnoreAll
    private List<ModuleGroup> childrenGroups;
    @IgnoreAll
    private Boolean existNextData;
    /**
     * 当前分组中模型个数
     */
    @IgnoreAll
    private Integer count;
}
