package com.bocloud.ams.entity.module;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;

/**
 * @Description: cmdb属性池配置项
 * 表格项： name：结构项名称  value：结构项ID   type：值类型  prop：枚举值
 * 下拉选择： name：属性  value：属性值
 * @Author majiali
 * @CreateTime 2022/5/5 14:02
 */
@Data
@Table("ci_property_pool_item")
@EqualsAndHashCode(callSuper = true)
public class PropertyPoolItem extends GenericEntity {
    /**
     * 主键ID
     * ci_property_pool_item.id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 所属属性池id
     * ci_property_pool_item.property_pool_id
     */
    @Column("property_pool_id")
    private Long propertyPoolId;


    /**
     *
     * ci_property_pool_item.code
     */
    @Column("code")
    private String code;

    /**
     *
     * ci_property_pool_item.value
     */
    @Column("value")
    private String value;

    /**
     * TEXTFIELD:单行文本
     * TEXTAREA:多行文本
     * SELECTREDIO:下拉单选
     * SELECTCHECKBOX:下拉多选
     * DATE:日期
     * TIME:时间
     * TEXTENCRYPT:数据加密
     * INTEGER:整数
     * FLOAT:小数
     * JSON:json
     * BOOLEAN:布尔值
     * ci_property_pool_item.type
     */
    @Column("type")
    private String type = "TEXTFIELD";

    /**
     * 引入模型中的属性id
     */
    @IgnoreAll
    private Long propertyId;

    /**
     * 引入模型id
     */
    @IgnoreAll
    private Long moduleId;

    @Column("item_value")
    private String itemValue;

    /**
     * 表格属性枚举值
     */
    @IgnoreAll
    private List<PropertyPoolItem> itemList;
}
