package com.bocloud.ams.repository;

import com.bocloud.ams.entity.TableLog;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author majiali
 * @date 2023/4/20
 */
@Repository("tableLogRepository")
public class TableLogRepository extends BasicGenericDao<TableLog, Long> {
    public TableLogRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public List<TableLog> query(String templateTable) {
        String sql = "select * from ci_table_log a where a.template_table = :templateTable and status='SUCCESS' and is_deleted = 0 ";
        List<TableLog> list = this.list(TableLog.class, sql, MapTools.simpleMap("templateTable", templateTable));
        return list;
    }
}
