package com.bocloud.ams.repository.association;

import com.bocloud.ams.entity.association.AutoRelationRuleItemValue;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Author liuyuanyuan
 * @Date 2022/5/12 0012 20:05
 * @Description:
 */
@Repository
public class AutoRelationRuleItemValueRepository extends BasicGenericDao<AutoRelationRuleItemValue, Long> {

    public AutoRelationRuleItemValueRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public boolean deleteByRuleId(Long ruleId, Long userId) throws Exception {
        String sql = "update ci_auto_relation_rule_item_value set is_deleted = 1, gmt_modify = :gmtModify, mender_id = :menderId where relation_rule_id = :ruleId ";
        Map<String, Object> params = MapTools.simpleMap("ruleId", ruleId);
        params.put("gmtModify", new Date());
        params.put("menderId", userId);
        return this.execute(sql, params) > 0;
    }

    public List<AutoRelationRuleItemValue> queryByItemId(Long itemId) throws Exception {
        String sql = "select * from ci_auto_relation_rule_item_value where is_deleted=0 and item_id = :itemId ";
        return this.list(AutoRelationRuleItemValue.class, sql, MapTools.simpleMap("itemId", itemId));
    }

    public List<AutoRelationRuleItemValue> queryAllByItemId(Long itemId) throws Exception {
        String sql = "select a.*,if(a.source_module_id is not null ,sp.code,spi.code) source_field_code," + " if(a.target_module_id is not null ,tp.code,tpi.code) target_field_code," + " if(a.source_module_id is not null ,sp.name,spi.name) source_field_name," + " if(a.target_module_id is not null ,tp.name,tpi.name) target_field_name ," + " if(a.source_module_id is not null ,sp.type,spi.type) source_field_type," + " if(a.target_module_id is not null ,tp.type,tpi.type) target_field_type " + " from ci_auto_relation_rule_item_value a " + "  left join ci_property sp on a.source_property_id =sp.id and sp.is_deleted =0 " + "  left join ci_property tp on a.target_property_id =tp.id and tp.is_deleted =0 " + "  left join ci_property_item spi on a.source_property_id = spi.id  and spi.is_deleted =0 " + "  left join ci_property_item tpi on a.target_property_id = tpi.id  and tpi.is_deleted =0 " + "  where a.is_deleted=0 and a.item_id = :itemId";
        return this.list(AutoRelationRuleItemValue.class, sql, MapTools.simpleMap("itemId", itemId));
    }

}
