package com.bocloud.ams.repository.audit;

import com.bocloud.ams.entity.audit.OperationalAudit;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.Common;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @Author liuyuanyuan
 * @Date 2022/5/23 0023 17:47
 * @Description:
 */
@Repository
public class OperationalAuditRepository extends BasicGenericDao<OperationalAudit, Long> {

    public OperationalAuditRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public int count(List<Param> params) throws Exception {
        String sql = "select count(1) from ci_operational_audit where is_deleted = 0 ";
        sql = getQueryBuilder().buildRaw(sql, params, null, "");
        return this.countQuery(sql, getQueryBuilder().getParam(params)).intValue();
    }

    public List<OperationalAudit> list(Pager pager) throws Exception {
        String sql = "select * from ci_operational_audit where is_deleted = 0 ";
        sql = getQueryBuilder().buildRaw(sql, pager, null);
        return this.list(OperationalAudit.class, sql);
    }

    public OperationalAudit query(Long id) throws Exception {
        String sql = "select * from ci_operational_audit where is_deleted=0 and id = :id";
        List<OperationalAudit> list = this.list(OperationalAudit.class, sql, MapTools.simpleMap(Common.ID, id));
        return list.isEmpty() ? null : list.get(0);
    }

    public List<OperationalAudit> list(List<Param> params) throws Exception {
        String sql = "select * from ci_operational_audit a where 1 = 1";
        sql = getQueryBuilder().buildRaw(sql, params, null, "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.list(OperationalAudit.class, sql, paramMap);
    }

    public List<OperationalAudit> list(List<Param> params, int rows) throws Exception {
        String sql = "select * from ci_operational_audit a where 1 = 1";
        sql = getQueryBuilder().buildRaw(sql, new Pager(1, rows, params, new HashMap<>()), "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.list(OperationalAudit.class, sql, paramMap);
    }

    public boolean delete(List<Long> ids) {
        String sql = "delete from ci_operational_audit where id in (:ids)";
        Map<String, Object> params = MapTools.simpleMap("ids", ids);
        return this.execute(sql, params) > 0;
    }

    public List<OperationalAudit> listTime(List<Param> params) throws Exception {
        String sql = "select distinct left(gmt_create,7) as dateStr from ci_operational_audit a where 1 = 1";
        sql = getQueryBuilder().buildRaw(sql, params, null, "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.list(OperationalAudit.class, sql, paramMap);
    }

}
