package com.bocloud.ams.repository.module;

import com.bocloud.ams.entity.module.PropertyGroup;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author 胡立伟
 * @program: bocloud.ams
 * @description:
 * @date 2022/5/5 12:01
 */
@Repository
public class PropertyGroupRepository extends BasicGenericDao<PropertyGroup, Long> {

    public PropertyGroupRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public boolean deleteByModuleId(Long moduleId, Long userId) throws Exception {
        String sql = "update ci_property_group set is_deleted = 1, gmt_modify = :gmtModify, mender_id = :menderId where module_id = :moduleId ";
        Map<String, Object> params = MapTools.simpleMap("moduleId", moduleId);
        params.put("gmtModify", new Date());
        params.put("menderId", userId);
        return this.execute(sql, params) > 0;
    }

    public List<PropertyGroup> listByModuleId(Long moduleId) {
        String sql = "select a.*  from ci_property_group a  where a.module_id = :moduleId and a.is_deleted = 0";
        return this.list(PropertyGroup.class, sql, MapTools.simpleMap("moduleId", moduleId));
    }

}
