package com.bocloud.ams.service.collection;

import com.bocloud.ams.entity.collection.CollectionTask;
import com.bocloud.ams.entity.collection.CollectionTaskInstance;
import com.bocloud.ams.entity.model.OperateParam;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;

/**
 * @Author liuyuanyuan
 * @Date 2022/6/8 0008 17:10
 * @Description:
 */
public interface CollectionTaskService {
    GeneralResult<Long> start(Long id, RequestContext context);
    CollectionTaskInstance initInstance(CollectionTask task, RequestContext context);

    CollectionTask basic(Long id);

    GeneralResult<CollectionTask> isValid(String expression);

    GeneralResult<GridBean<CollectionTask>> list(Pager pager);

    GeneralResult<CollectionTask> save(CollectionTask task, RequestContext context);

    GeneralResult<CollectionTask> modify(CollectionTask bean, RequestContext context);

    GeneralResult<CollectionTask> modifyType(Long id, RequestContext context);

    GeneralResult<CollectionTask> detail(Long id);

    GeneralResult<Void> remove(Long id, Long target);

    /**
     * 判断是否存在高危命令
     *
     * @param task
     * @param userId
     * @return
     */
    GeneralResult<Void> checkCommand(CollectionTask task, Long userId);

    /**
     * 高危命令处理
     *
     * @param
     * @param
     * @return
     */
//    public GeneralResult<Void> commandHandler(Long userId, String content);

    GeneralResult<Void> operate(OperateParam operateParam,  Long id , Long target);

    GeneralResult<String> removeScheduleIfLeader(Long id);

    GeneralResult<String> addScheduleIfLeader(Long id );

    void onApplicationReadyEvent();
}
