package com.bocloud.ams.service.config;

import com.alibaba.fastjson.JSONArray;
import com.bocloud.ams.entity.config.CmdbConfig;
import com.megatron.common.exception.InternalServerException;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.RequestContext;
import com.megatron.common.model.Result;

import java.util.List;
import java.util.Map;

public interface CmdbConfigService {

    /**
     * 更新配置
     *
     * @param config
     * @return
     */
    Result modify(CmdbConfig config) throws InternalServerException;

    /**
     * 批量修改
     *
     * @param list
     * @param context
     * @return
     */
    Result batchUpdate(List<CmdbConfig> list, RequestContext context);

    GeneralResult<Map<String, String>> listConfigs(String category, List<String> codes);

    GeneralResult<JSONArray> listCategoryTree(String category);

}
