package com.bocloud.ams.service.instance;

import com.bocloud.ams.entity.instance.InstanceRelation;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;

import java.util.List;

/**
 * @Author majiali
 * @Date 2022/6/8 15:49
 * @Version 1.0
 **/
public interface InstanceRelationHistoryRecordService {

    /**
     * 获取详情
     *
     * @param id
     * @return
     */
    public GeneralResult detail(Long id) throws Exception;

    /**
     * 列表分页查询
     *
     * @param pager
     * @return
     */
    public GeneralResult list(Pager pager);

    public GeneralResult cancel(Long id, RequestContext context);

    public GeneralResult reconcile(Long id, RequestContext context);

    public GeneralResult preflight(Long id, RequestContext context);

    public GeneralResult batchCancel(List<Long> ids, RequestContext context);

    /**
     * @param instanceRelation 实例关系
     * @param isSource         当前实例是否是源实例
     * @param status           状态 SUCCESS-成功  FAILED-失败
     * @param type             类型 CANCEL-取消关联 RELATION-关联
     * @param reason           失败原因
     * @param context
     * @Description: 添加关联历史（手动关联）
     * @Author majiali
     * @CreateTime 2022/6/14 16:13
     */
    public GeneralResult save(InstanceRelation instanceRelation, boolean isSource, String status, String type, String reason, RequestContext context);

}
