package com.bocloud.ams.service.instance;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.ams.entity.instance.Instance;
import com.bocloud.ams.entity.model.InstanceBean;
import com.bocloud.ams.entity.model.InstanceTopo;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: CmdbInstanceService
 * @Description
 * @Author yangzhenrong
 * @Date 2022/5/11 11:16
 * @Version 1.0
 **/
public interface InstanceService {

    GeneralResult<Void> createTable(String moduleCode, Long userId);

    GeneralResult<Void> dropTable(String moduleCode, Long userId);

    GeneralResult list(Pager pager, Long userId);

    GeneralResult create(JSONObject instance, Long userId, boolean isAutoRelation);

    GeneralResult<Void> remove(Long id, String moduleCode, Long userId);

    GeneralResult<Void> batchRemove(InstanceBean model, Long userId);

    GeneralResult modify(JSONObject instance, Long userId);

    GeneralResult<Void> batchModify(InstanceBean instanceModel, Long userId);

    GeneralResult<Instance> detail(Long id, String moduleCode);

    GeneralResult export(Long moduleId, String moduleCode, String type, Long userId);

    GeneralResult download(Long moduleId, String moduleCode, String type, Long userId);

    GeneralResult upload(Long moduleId, String moduleCode, MultipartFile excel, RequestContext context);

    GeneralResult initInstance(JSONObject object, String type);

    GeneralResult<InstanceTopo> topo(Long id, Long relationCategoryId, Long moduleId, Long userId);

    boolean checkAdminRole(Long userId);

    void convertInstanceValue(List<Map<String, Object>> list, Long moduleId, Long userId, boolean hasAdminRole) throws Exception;

}
