package com.bocloud.ams.service.utils;

/**
 * @Description: 关联历史类型常量
 * @Author: majiali
 * @CreateTime: 2022/6/8 10:12
 */
public class RelationHistoryConstant {

    /**
     * 待调和记录预检失败，数据冲突错误提示
     */
    public static String RECONCILED_ERROR_MSG = "因该待调和记录的资源实例关系与目前库中已存在的资源实例关系产生矛盾，系统自动取消数据调和任务";
    public static String CANCEL_ERROR_MSG = "手动取消数据调和任务";
    public static String NO_MODULE_ERROR_MSG = "因未查询到模型关系相关信息，系统自动取消数据调和任务";
    public static String NO_INSTANCE_RELATION_ERROR_MSG = "因未查询到实例关系相关信息，系统自动取消数据调和任务";
    public static String NO_INSTANCE_ERROR_MSG = "因未查询到实例相关信息，系统自动取消数据调和任务";

    /**
     * @Description: 状态
     */
    public enum Status {
        //成功
        SUCCESS("SUCCESS"),
        //失败
        FAILED("FAILED"),
        //待调和
        RECONCILED("RECONCILED");
        private final String value;

        Status(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    //操作类型
    public enum Type {
        //取消关联
        CANCEL("CANCEL"),
        //关联
        RELATION("RELATION");
        private final String value;

        Type(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

    //关联方式
    public enum Way {
        //手动
        MANUAL("MANUAL"),
        //自动
        AUTO("AUTO");
        private final String value;

        Way(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

}
