package com.bocloud.ams.task.executor;

import com.bocloud.ams.task.listener.MaintainTaskListener;
import com.bocloud.ams.task.model.Job;
import com.bocloud.ams.task.model.JobResult;
import com.bocloud.ams.task.model.enums.TaskParam;
import com.bocloud.cmp.boot.model.BoCloudExchange;
import com.megatron.common.utils.Common;
import lombok.extern.slf4j.Slf4j;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Component;

/**
 * @Author liuyuanyuan
 * @Date 2022/6/9 0009 13:42
 * @Description:
 */
@Slf4j
@Component
public class TaskJobSubmit {
    @Autowired
    private MaintainTaskListener maintainTaskListener;
    @Autowired
    private AmqpTemplate amqpTemplate;
    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    public Boolean subJob(Job job) {
        log.info("任务提交 【{}】," + System.currentTimeMillis(), job.getParam(Common.NAME));
        try {
            taskExecutor.execute(() -> {
                String type = job.getParam(TaskParam.TASKTYPE.name());
                if ("maintain".equalsIgnoreCase(type)) {
                    JobResult jobResult = maintainTaskListener.onTask(job);
                    amqpTemplate.convertAndSend(BoCloudExchange.Default.DIRECT.getExchange(), "cmdb.task.result.queue", jobResult);
                }
            });
            return true;
        } catch (Exception e) {
            log.error("Task delivery failure:", e);
            return false;
        }
    }
}
