package com.bocloud.ams.task.model;

import com.bocloud.ams.task.utils.DBDriver;
import com.megatron.common.model.GeneralResult;
import org.apache.commons.lang3.StringUtils;

import java.util.List;

/**
 * @ Description： @ Author ：丁明威 @ Date ：Created in 11:27 2018/12/26 @ Modified By：
 */
public class DBFront {
    private String category;
    private String driver;
    private String database;
    private Long scriptId;
    private List<Long> groupId;
    private String jdbcUrl;
    private String username;
    private String password;
    private String content;

    public DBFront(String category, String driver, Long scriptId, List<Long> groupId, String jdbcUrl, String username,
                   String password, String content, String database) {
        this.category = category;
        this.driver = driver;
        this.scriptId = scriptId;
        this.groupId = groupId;
        this.jdbcUrl = jdbcUrl;
        this.username = username;
        this.password = password;
        this.content = content;
        this.database = database;
    }

    public DBFront() {
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public DBDriver getDBDriver() throws Exception {
        if (StringUtils.isEmpty(database)) {
            throw new Exception("database driver is null!");
        }
        GeneralResult<DBDriver> hasResult = DBDriver.has(database);
        if (hasResult.isFailed()) {
            throw new Exception("no specific driver found!");
        } else {
            return hasResult.getData();
        }
    }

    public String getDriver() {
        return driver;
    }

    public void setDriver(String driver) {
        this.driver = driver;
    }

    public Long getScriptId() {
        return scriptId;
    }

    public void setScriptId(Long scriptId) {
        this.scriptId = scriptId;
    }

    public List<Long> getGroupId() {
        return groupId;
    }

    public void setGroupId(List<Long> groupId) {
        this.groupId = groupId;
    }

    public String getJdbcUrl() {
        return jdbcUrl;
    }

    public void setJdbcUrl(String jdbcUrl) {
        this.jdbcUrl = jdbcUrl;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getDatabase() {
        return database;
    }

    public void setDatabase(String database) {
        this.database = database;
    }
}