package com.bocloud.ams.task.model;

/**
 * Worker执行的脚本内容封装类
 *
 * @author dmw
 */
public class WorkerScript {

    /**
     * 脚本类型
     */
    private String type;
    /**
     * 脚本参数
     */
    private String params;
    /**
     * 脚本内容
     */
    private String content;
    /**
     * 执行脚本时候的可选参数
     */
    private Option options;

    public WorkerScript(String type, String params, String content) {
        super();
        this.type = type;
        this.params = params;
        this.content = content;
    }

    public WorkerScript(String type, String params, String content, Option options) {
        super();
        this.type = type;
        this.params = params;
        this.content = content;
        this.options = options;
    }

    /**
     * @return the options
     */
    public Option getOptions() {
        return options;
    }

    /**
     * @param options the options to set
     */
    public void setOptions(Option options) {
        this.options = options;
    }

    /**
     * @return the type
     */
    public String getType() {
        return type;
    }

    /**
     * @param type the type to set
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * @return the params
     */
    public String getParams() {
        return params;
    }

    /**
     * @param params the params to set
     */
    public void setParams(String params) {
        this.params = params;
    }

    /**
     * @return the content
     */
    public String getContent() {
        return content;
    }

    /**
     * @param content the content to set
     */
    public void setContent(String content) {
        this.content = content;
    }

    /*
     * (non-Javadoc)
     *
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "WorkerScript [type=" + type + ", params=" + params + ", content=" + content + ", options=" + options
                + "]";
    }

}
