package com.bocloud.ams.task.model.enums;

import com.megatron.common.model.GeneralResult;
import org.apache.commons.lang3.StringUtils;

/**
 * 任务参数
 *
 * @author dmw
 */
public enum TaskParam {

    /**
     * 任务类型：resource,maintain,software,scheduled
     */
    TASKTYPE,
    /**
     * 上级任务，主要用来记录定时任务的ID
     */
    TASKPJOB,
    /**
     * 任务数据
     */
    TASKDATA,
    /**
     * 任务编码
     */
    TASKCODE,
    /**
     * 超时时间
     */
    TIMEOUT,
    /**
     *
     */
    TARGETS,
    /**
     *
     */
    RECORDID,
    /**
     *
     */
    USERID,
    /**
     *
     */
    PUREREAL,
    /**
     *
     */
    INSTANCEID,
    /**
     *
     */
    RETRYTIMES,
    /**
     * 任务队列
     */
    QUEUE;

    public static GeneralResult<TaskParam> hasValue(String value) {
        if (StringUtils.isEmpty(value)) {
            return new GeneralResult<>(false, "参数为空！");
        }
        TaskParam[] params = TaskParam.values();
        for (TaskParam param : params) {
            if (param.name().equalsIgnoreCase(value)) {
                return new GeneralResult<TaskParam>(true, param, "success");
            }
        }
        return new GeneralResult<>(false, "数值不存在！");
    }
}
